"use strict";
var _AudioVisual_instances, _AudioVisual_analyzer_node, _AudioVisual_svg_injecting_element, _AudioVisual_shape, _AudioVisual_buffer_length, _AudioVisual_fft_multiplier, _AudioVisual_fft_offset, _AudioVisual_from_fft_range, _AudioVisual_to_fft_range, _AudioVisual_point_count, _AudioVisual_canvas_height, _AudioVisual_canvas_width, _AudioVisual_fft_data, _AudioVisual_get_cured_frequency_data, _AudioVisual_normalise_perpendicular_anchors, _AudioVisual_create_perpendicular_anchors, _AudioVisual_catmull_rom_smooth, _AudioVisual_mutate_points, _AudioVisual_convert_range, _AudioVisual_create_svg_element, _AudioVisualBuilder_instances, _AudioVisualBuilder_analyzer_node, _AudioVisualBuilder_svg_injecting_element, _AudioVisualBuilder_canvas_height, _AudioVisualBuilder_canvas_width, _AudioVisualBuilder_buffer_length, _AudioVisualBuilder_smoothing_algorythm, _AudioVisualBuilder_fft_size, _AudioVisualBuilder_fft_multipier, _AudioVisualBuilder_fft_offset, _AudioVisualBuilder_from_fft_range, _AudioVisualBuilder_to_fft_range, _AudioVisualBuilder_point_count, _AudioVisualBuilder_create_shape, _AudioVisualBuilder_get_cured_frequency_data;
Object.defineProperty(exports, "__esModule", { value: true });
exports.AudioVisualBuilder = exports.AudioVisual = exports.ShapeType = exports.SmoothingAlgorythm = void 0;
const tslib_1 = require("tslib");
var SmoothingAlgorythm;
(function (SmoothingAlgorythm) {
    SmoothingAlgorythm[SmoothingAlgorythm["Linear"] = 0] = "Linear";
    SmoothingAlgorythm[SmoothingAlgorythm["BezierPerpendicular"] = 1] = "BezierPerpendicular";
    SmoothingAlgorythm[SmoothingAlgorythm["CatmullRom"] = 2] = "CatmullRom";
    SmoothingAlgorythm[SmoothingAlgorythm["BezierWeighted"] = 3] = "BezierWeighted";
})(SmoothingAlgorythm = exports.SmoothingAlgorythm || (exports.SmoothingAlgorythm = {}));
var ShapeType;
(function (ShapeType) {
    ShapeType[ShapeType["Circle"] = 0] = "Circle";
    ShapeType[ShapeType["Line"] = 1] = "Line";
    /*To be Implmeneted
    Custom,
    Waveform,
    FullSongWaveForm
    */
})(ShapeType = exports.ShapeType || (exports.ShapeType = {}));
class AudioVisual {
    constructor(analyzer_node, svg_injecting_element, shape, buffer_length, fft_multiplier, fft_offset, from_fft_range, to_fft_range, point_count) {
        _AudioVisual_instances.add(this);
        _AudioVisual_analyzer_node.set(this, void 0);
        _AudioVisual_svg_injecting_element.set(this, void 0);
        _AudioVisual_shape.set(this, void 0);
        _AudioVisual_buffer_length.set(this, void 0);
        _AudioVisual_fft_multiplier.set(this, void 0);
        _AudioVisual_fft_offset.set(this, void 0);
        _AudioVisual_from_fft_range.set(this, void 0);
        _AudioVisual_to_fft_range.set(this, void 0);
        _AudioVisual_point_count.set(this, void 0);
        _AudioVisual_canvas_height.set(this, void 0);
        _AudioVisual_canvas_width.set(this, void 0);
        _AudioVisual_fft_data.set(this, void 0);
        tslib_1.__classPrivateFieldSet(this, _AudioVisual_analyzer_node, analyzer_node, "f");
        tslib_1.__classPrivateFieldSet(this, _AudioVisual_svg_injecting_element, svg_injecting_element, "f");
        tslib_1.__classPrivateFieldSet(this, _AudioVisual_shape, shape, "f");
        tslib_1.__classPrivateFieldSet(this, _AudioVisual_buffer_length, buffer_length, "f");
        tslib_1.__classPrivateFieldSet(this, _AudioVisual_fft_multiplier, fft_multiplier, "f");
        tslib_1.__classPrivateFieldSet(this, _AudioVisual_fft_offset, fft_offset, "f");
        tslib_1.__classPrivateFieldSet(this, _AudioVisual_from_fft_range, from_fft_range, "f");
        tslib_1.__classPrivateFieldSet(this, _AudioVisual_to_fft_range, to_fft_range, "f");
        tslib_1.__classPrivateFieldSet(this, _AudioVisual_point_count, point_count, "f");
        tslib_1.__classPrivateFieldSet(this, _AudioVisual_fft_data, new Float32Array(), "f");
        tslib_1.__classPrivateFieldSet(this, _AudioVisual_canvas_width, svg_injecting_element.viewBox.baseVal.width, "f");
        tslib_1.__classPrivateFieldSet(this, _AudioVisual_canvas_height, svg_injecting_element.viewBox.baseVal.height, "f");
    }
    draw() {
        tslib_1.__classPrivateFieldGet(this, _AudioVisual_analyzer_node, "f").getFloatFrequencyData(tslib_1.__classPrivateFieldGet(this, _AudioVisual_fft_data, "f"));
        tslib_1.__classPrivateFieldGet(this, _AudioVisual_svg_injecting_element, "f").innerHTML = tslib_1.__classPrivateFieldGet(this, _AudioVisual_instances, "m", _AudioVisual_create_svg_element).call(this);
        requestAnimationFrame(this.draw.bind(this));
    }
}
exports.AudioVisual = AudioVisual;
_AudioVisual_analyzer_node = new WeakMap(), _AudioVisual_svg_injecting_element = new WeakMap(), _AudioVisual_shape = new WeakMap(), _AudioVisual_buffer_length = new WeakMap(), _AudioVisual_fft_multiplier = new WeakMap(), _AudioVisual_fft_offset = new WeakMap(), _AudioVisual_from_fft_range = new WeakMap(), _AudioVisual_to_fft_range = new WeakMap(), _AudioVisual_point_count = new WeakMap(), _AudioVisual_canvas_height = new WeakMap(), _AudioVisual_canvas_width = new WeakMap(), _AudioVisual_fft_data = new WeakMap(), _AudioVisual_instances = new WeakSet(), _AudioVisual_get_cured_frequency_data = function _AudioVisual_get_cured_frequency_data() {
    tslib_1.__classPrivateFieldSet(this, _AudioVisual_fft_data, new Float32Array(tslib_1.__classPrivateFieldGet(this, _AudioVisual_buffer_length, "f")), "f");
    tslib_1.__classPrivateFieldGet(this, _AudioVisual_analyzer_node, "f").getFloatFrequencyData(tslib_1.__classPrivateFieldGet(this, _AudioVisual_fft_data, "f"));
    const from = Math.round((tslib_1.__classPrivateFieldGet(this, _AudioVisual_point_count, "f") / 100) * tslib_1.__classPrivateFieldGet(this, _AudioVisual_from_fft_range, "f"));
    const to = Math.round(tslib_1.__classPrivateFieldGet(this, _AudioVisual_buffer_length, "f") - (tslib_1.__classPrivateFieldGet(this, _AudioVisual_buffer_length, "f") / 100) * tslib_1.__classPrivateFieldGet(this, _AudioVisual_to_fft_range, "f"));
    const squeeze_factor = Math.round((tslib_1.__classPrivateFieldGet(this, _AudioVisual_buffer_length, "f") - to) / tslib_1.__classPrivateFieldGet(this, _AudioVisual_point_count, "f"));
    const return_array = new Array(tslib_1.__classPrivateFieldGet(this, _AudioVisual_point_count, "f"));
    for (let i = 0; i < tslib_1.__classPrivateFieldGet(this, _AudioVisual_point_count, "f") + 1; i++) {
        return_array[i] = tslib_1.__classPrivateFieldGet(this, _AudioVisual_fft_data, "f")[from + i * squeeze_factor];
    }
    return return_array;
}, _AudioVisual_normalise_perpendicular_anchors = function _AudioVisual_normalise_perpendicular_anchors(x, y) {
    const magnitude = Math.sqrt(x * x + y * y);
    return [x / magnitude, y / magnitude];
}, _AudioVisual_create_perpendicular_anchors = function _AudioVisual_create_perpendicular_anchors(arr) {
    const anchors = [];
    switch (tslib_1.__classPrivateFieldGet(this, _AudioVisual_shape, "f").shape_type) {
        case ShapeType.Circle: {
            const pointDistance = 7;
            for (let curPoint = 0; curPoint < arr.length; curPoint++) {
                const [dx, dy] = tslib_1.__classPrivateFieldGet(this, _AudioVisual_instances, "m", _AudioVisual_normalise_perpendicular_anchors).call(this, arr[curPoint].x, arr[curPoint].y);
                const perpendicular = [-dy, dx];
                anchors.push({
                    leftAnchor: {
                        x: arr[curPoint].x + pointDistance * perpendicular[0],
                        y: arr[curPoint].y + pointDistance * perpendicular[1],
                    },
                    rightAnchor: {
                        x: arr[curPoint].x - pointDistance * perpendicular[0],
                        y: arr[curPoint].y - pointDistance * perpendicular[1],
                    },
                });
            }
            break;
        }
        case ShapeType.Line: {
            const pointDistance = tslib_1.__classPrivateFieldGet(this, _AudioVisual_canvas_width, "f") / arr.length;
            for (let curPoint = 0; curPoint < arr.length; curPoint++) {
                anchors.push({
                    leftAnchor: {
                        x: pointDistance * curPoint - pointDistance / 3,
                        y: arr[curPoint].y,
                    },
                    rightAnchor: {
                        x: pointDistance * curPoint + pointDistance / 3,
                        y: arr[curPoint].y,
                    },
                });
            }
        }
    }
    return anchors;
}, _AudioVisual_catmull_rom_smooth = function _AudioVisual_catmull_rom_smooth(arr, k) {
    if (k == null)
        k = 1;
    const last = arr.length - 2;
    let path = "M" + [arr[0].x, arr[0].y];
    for (let i = 0; i < arr.length - 1; i++) {
        const x0 = i ? arr[i - 1].x : arr[0].x;
        const y0 = i ? arr[i - 1].y : arr[0].y;
        const x1 = arr[i].x;
        const y1 = arr[i].y;
        const x2 = arr[i + 1].x;
        const y2 = arr[i + 1].y;
        let subx = y2;
        let suby = y2;
        //Makes the last line before Z a bit less jarring
        if (tslib_1.__classPrivateFieldGet(this, _AudioVisual_shape, "f").shape_type == ShapeType.Circle) {
            subx = arr[0].x;
            suby = arr[0].y;
        }
        const x3 = i !== last ? arr[i + 2].x : subx;
        const y3 = i !== last ? arr[i + 2].y : suby;
        const cp1x = x1 + (x2 - x0) / 6 * k;
        const cp1y = y1 + (y2 - y0) / 6 * k;
        const cp2x = x2 - (x3 - x1) / 6 * k;
        const cp2y = y2 - (y3 - y1) / 6 * k;
        path += "C" + [cp1x, cp1y, cp2x, cp2y, x2, y2];
    }
    path += " Z";
    return path;
}, _AudioVisual_mutate_points = function _AudioVisual_mutate_points() {
    const mutated_points = [];
    const frequency_data = tslib_1.__classPrivateFieldGet(this, _AudioVisual_instances, "m", _AudioVisual_get_cured_frequency_data).call(this);
    const out_range = [0, tslib_1.__classPrivateFieldGet(this, _AudioVisual_canvas_height, "f")];
    const in_range = [-165, -30];
    switch (tslib_1.__classPrivateFieldGet(this, _AudioVisual_shape, "f").shape_type) {
        case ShapeType.Line: {
            for (let i = 0; i < frequency_data.length - 1; i++) {
                mutated_points.push({
                    x: tslib_1.__classPrivateFieldGet(this, _AudioVisual_shape, "f").points[i].x /** ((Math.max(FFTDataArray[i] + 100)) * 4)*/,
                    y: tslib_1.__classPrivateFieldGet(this, _AudioVisual_shape, "f").points[i].y - tslib_1.__classPrivateFieldGet(this, _AudioVisual_instances, "m", _AudioVisual_convert_range).call(this, frequency_data[i] * tslib_1.__classPrivateFieldGet(this, _AudioVisual_fft_multiplier, "f") + tslib_1.__classPrivateFieldGet(this, _AudioVisual_fft_offset, "f"), in_range, out_range),
                });
            }
            break;
        }
        case ShapeType.Circle: {
            for (let i = 0; i < frequency_data.length - 1; i++) {
                const new_i = i > (frequency_data.length - 1) / 2 ? frequency_data.length - 1 - i : i;
                mutated_points.push({
                    x: tslib_1.__classPrivateFieldGet(this, _AudioVisual_shape, "f").points[i].x * Math.max((frequency_data[new_i] * tslib_1.__classPrivateFieldGet(this, _AudioVisual_fft_multiplier, "f") + tslib_1.__classPrivateFieldGet(this, _AudioVisual_fft_offset, "f")) / 50, 1) + tslib_1.__classPrivateFieldGet(this, _AudioVisual_canvas_width, "f") / 2,
                    y: tslib_1.__classPrivateFieldGet(this, _AudioVisual_shape, "f").points[i].y * Math.max((frequency_data[new_i] * tslib_1.__classPrivateFieldGet(this, _AudioVisual_fft_multiplier, "f") + tslib_1.__classPrivateFieldGet(this, _AudioVisual_fft_offset, "f")) / 50, 1) + tslib_1.__classPrivateFieldGet(this, _AudioVisual_canvas_height, "f") / 2,
                });
                /* TODO: IMPLEMENT SCALING TO BEAT
                this.injectingHTMLElement.parentElement.style.transform = `scale(${(100 + Math.max((frequencyData[2] * 2 + 130) / 5, 1)) / 100})`
                */
            }
            break;
        }
    }
    return mutated_points;
}, _AudioVisual_convert_range = function _AudioVisual_convert_range(value, r1, r2) {
    if (!isFinite(value))
        return 0;
    return ((value - r1[0]) * (r2[1] - r2[0])) / (r1[1] - r1[0]) + r2[0];
}, _AudioVisual_create_svg_element = function _AudioVisual_create_svg_element() {
    let path;
    const arr = tslib_1.__classPrivateFieldGet(this, _AudioVisual_instances, "m", _AudioVisual_mutate_points).call(this);
    switch (tslib_1.__classPrivateFieldGet(this, _AudioVisual_shape, "f").shape_type) {
        case ShapeType.Line: {
            path = `M ${0} ${tslib_1.__classPrivateFieldGet(this, _AudioVisual_canvas_height, "f")} `;
            break;
        }
        case ShapeType.Circle: {
            path = `M ${arr[0].x} ${arr[0].y} `;
        }
    }
    switch (tslib_1.__classPrivateFieldGet(this, _AudioVisual_shape, "f").smoothing_algorythm) {
        case SmoothingAlgorythm.Linear: {
            for (let i = 0; i < arr.length; i++) {
                path += `L ${arr[i].x},${arr[i].y} `;
            }
            if (tslib_1.__classPrivateFieldGet(this, _AudioVisual_shape, "f").shape_type == ShapeType.Line) {
                path += `L ${tslib_1.__classPrivateFieldGet(this, _AudioVisual_canvas_width, "f")} ${tslib_1.__classPrivateFieldGet(this, _AudioVisual_canvas_height, "f") / 2} `;
                //path += `L ${canvas_width} ${canvas_height} `
            }
            path += `Z `;
            break;
        }
        case SmoothingAlgorythm.BezierPerpendicular: {
            const anchors = tslib_1.__classPrivateFieldGet(this, _AudioVisual_instances, "m", _AudioVisual_create_perpendicular_anchors).call(this, arr);
            for (let i = 1; i < arr.length; i++) {
                path += `C ${anchors[i - 1].rightAnchor.x} ${anchors[i - 1].rightAnchor.y} ${anchors[i].leftAnchor.x} ${anchors[i].leftAnchor.y} ${arr[i].x} ${arr[i].y} `;
            }
            if (tslib_1.__classPrivateFieldGet(this, _AudioVisual_shape, "f").shape_type == ShapeType.Line) {
                //path += `L ${this.canvasWidth} ${this.canvasHeight / 2} `
                path += `L ${tslib_1.__classPrivateFieldGet(this, _AudioVisual_canvas_width, "f")} ${tslib_1.__classPrivateFieldGet(this, _AudioVisual_canvas_height, "f")} `;
            }
            path += `Z `;
            break;
        }
        case SmoothingAlgorythm.BezierWeighted: {
            /*THIS IS VERY MUCH BROKEN ATM :(
            for (let i = 2; i < arr.length; i++) {
                const end = [arr.x[i], arr.y[i]] // the current point is the end of this segment of the curve
                path += `C ${startControl[0]} ${startControl[1]} ${endControl[0]} ${endControl[1]} ${end[0]} ${end[1]}`
            }*/
            console.error("BezierWeighted not implemented yet...");
            break;
        }
        case SmoothingAlgorythm.CatmullRom: {
            path = tslib_1.__classPrivateFieldGet(this, _AudioVisual_instances, "m", _AudioVisual_catmull_rom_smooth).call(this, arr, 1);
            break;
        }
    }
    return `<path width="100%" height="100%" d="${path}"/>`;
};
class AudioVisualBuilder {
    constructor(analyzer_node, svg_injecting_element) {
        _AudioVisualBuilder_instances.add(this);
        _AudioVisualBuilder_analyzer_node.set(this, void 0);
        _AudioVisualBuilder_svg_injecting_element.set(this, void 0);
        _AudioVisualBuilder_canvas_height.set(this, void 0);
        _AudioVisualBuilder_canvas_width.set(this, void 0);
        _AudioVisualBuilder_buffer_length.set(this, void 0);
        _AudioVisualBuilder_smoothing_algorythm.set(this, void 0);
        _AudioVisualBuilder_fft_size.set(this, void 0);
        _AudioVisualBuilder_fft_multipier.set(this, void 0);
        _AudioVisualBuilder_fft_offset.set(this, void 0);
        _AudioVisualBuilder_from_fft_range.set(this, void 0);
        _AudioVisualBuilder_to_fft_range.set(this, void 0);
        _AudioVisualBuilder_point_count.set(this, void 0);
        tslib_1.__classPrivateFieldSet(this, _AudioVisualBuilder_analyzer_node, analyzer_node, "f");
        tslib_1.__classPrivateFieldSet(this, _AudioVisualBuilder_svg_injecting_element, svg_injecting_element, "f");
        tslib_1.__classPrivateFieldSet(this, _AudioVisualBuilder_canvas_width, svg_injecting_element.viewBox.baseVal.width, "f");
        tslib_1.__classPrivateFieldSet(this, _AudioVisualBuilder_canvas_height, svg_injecting_element.viewBox.baseVal.height, "f");
        tslib_1.__classPrivateFieldSet(this, _AudioVisualBuilder_buffer_length, analyzer_node.frequencyBinCount, "f");
        tslib_1.__classPrivateFieldSet(this, _AudioVisualBuilder_smoothing_algorythm, SmoothingAlgorythm.Linear, "f");
        tslib_1.__classPrivateFieldSet(this, _AudioVisualBuilder_fft_size, 2048, "f");
        tslib_1.__classPrivateFieldSet(this, _AudioVisualBuilder_fft_multipier, 1.5, "f");
        tslib_1.__classPrivateFieldSet(this, _AudioVisualBuilder_fft_offset, 150, "f");
        tslib_1.__classPrivateFieldSet(this, _AudioVisualBuilder_from_fft_range, 0, "f");
        tslib_1.__classPrivateFieldSet(this, _AudioVisualBuilder_to_fft_range, 100, "f");
        tslib_1.__classPrivateFieldSet(this, _AudioVisualBuilder_point_count, Math.round((tslib_1.__classPrivateFieldGet(this, _AudioVisualBuilder_buffer_length, "f") / 100) * (tslib_1.__classPrivateFieldGet(this, _AudioVisualBuilder_from_fft_range, "f") - tslib_1.__classPrivateFieldGet(this, _AudioVisualBuilder_to_fft_range, "f"))), "f");
    }
    /**
     * The smoothingTimeConstant property of the AnalyserNode interface is a double value representing the averaging constant with the last analysis frame. It's basically an average between the current buffer and the last buffer the AnalyserNode processed, and results in a much smoother set of value changes over time.
     * @param fft_time_smoothing_i A double within the range 0 to 1 (0 meaning no time averaging). The default value is 0.8.
     * @returns this
     */
    set_fft_time_smoothing(fft_time_smoothing_i) {
        tslib_1.__classPrivateFieldGet(this, _AudioVisualBuilder_analyzer_node, "f").smoothingTimeConstant = fft_time_smoothing_i;
        return this;
    }
    /**
     * The fftSize property of the AnalyserNode interface is an unsigned long value and represents the window size in samples that is used when performing a Fast Fourier Transform (FFT) to get frequency domain data.
     *
     *  If the point count set for the analyzer is less than the fft_from > FFT_DATA > fft_to, points might go missing or something will break. In that case increase, otherwise keep to as low as possible due to performance reasons
     * @param fft_size Must be a power of 2 between 2^5 and 2^15, so one of: `32, 64, 128, 256, 512, 1024, 2048, 4096, 8192, 16384, and 32768.` Defaults to `2048`.
     * @returns this
     */
    set_fft_size(fft_size) {
        if (!(tslib_1.__classPrivateFieldGet(this, _AudioVisualBuilder_fft_size, "f") && !(tslib_1.__classPrivateFieldGet(this, _AudioVisualBuilder_fft_size, "f") & (tslib_1.__classPrivateFieldGet(this, _AudioVisualBuilder_fft_size, "f") - 1))))
            throw Error("fft_size not power of two");
        tslib_1.__classPrivateFieldGet(this, _AudioVisualBuilder_analyzer_node, "f").fftSize = tslib_1.__classPrivateFieldSet(this, _AudioVisualBuilder_fft_size, fft_size, "f");
        tslib_1.__classPrivateFieldSet(this, _AudioVisualBuilder_buffer_length, tslib_1.__classPrivateFieldGet(this, _AudioVisualBuilder_analyzer_node, "f").frequencyBinCount, "f");
        return this;
    }
    /**
     * Changes how the FFT data is parsed.
     * Limits the range like:
     *
     * `from_fft_range < FFT_DATA < to_fft_range`,
     *
     * then splits the remaining data evently between point_count.
     * `fft_multiplier` and `fft_offset` define how the data then affects the point mutation. FFT data goes from `-Infinity` to `0` (Noise floor usually around `-160`db from experience) Multiplying the number exaggerates the higher decibel changes, making the result more dynamic, whilst the offset keeps the visualizer from clipping.
     *
     * Reccomended values are around:
     *
     * `shape_type == line`
     *
     *  - multiplier: 3
     *
     *  - offset: -30
     *
     * `shape_type == circle`
     *
     *  - multiplier: 1.5
     *
     *  - offset: 150
     * @param param0
     * @returns
     */
    set_fft_data_tresholds({ from_fft_range_i = 0, to_fft_range_i = 100, point_count_i = Math.round((tslib_1.__classPrivateFieldGet(this, _AudioVisualBuilder_buffer_length, "f") / 100) * (from_fft_range_i - to_fft_range_i)), fft_multiplier_i = 2, fft_offset_i = -50 }) {
        tslib_1.__classPrivateFieldSet(this, _AudioVisualBuilder_from_fft_range, from_fft_range_i, "f");
        tslib_1.__classPrivateFieldSet(this, _AudioVisualBuilder_to_fft_range, to_fft_range_i, "f");
        tslib_1.__classPrivateFieldSet(this, _AudioVisualBuilder_point_count, point_count_i, "f");
        tslib_1.__classPrivateFieldSet(this, _AudioVisualBuilder_fft_multipier, fft_multiplier_i, "f");
        tslib_1.__classPrivateFieldSet(this, _AudioVisualBuilder_fft_offset, fft_offset_i, "f");
        return this;
    }
    /**
     * Defines what the svg d attribute path command will use.
     *
     * `Linear` - Uses no interpolation between points, jagged but very fast
     *
     * `BezierPerpendicular` - Sets the Cubic Bézier anchors perpendicular to the point. Great for Line shapes with no curves.
     *
     * `CatmullRom` - Uses Centripetal Catmull–Rom spline under the hood, then translates them to Cubic Bézier points. Best quality, worst performance.
     *
     * `BezierWeighted` - DO NOT USE! It's broken at the moment :/. Sets the Cubic Bézier anchors halfway between the next and previous point. Better than Linear on Circular shapes and doesn't have the "invards bulding" side effect of Catmull Rom

     * @param algorythm Linear = 0; BezierPerpendicular = 1; CatmullRom = 2; BezierWeighted = 3;
     * @returns
     */
    set_smoothing_algorythm(algorythm) {
        tslib_1.__classPrivateFieldSet(this, _AudioVisualBuilder_smoothing_algorythm, algorythm, "f");
        return this;
    }
    /**
     * Creates the Audio Visualizer. To start drawing, use .draw(). To further modify it's looks use CSS, eg:
     * ```css
     * svg {
     *   fill: grey;
     *   stroke: black;
     *   transform: rotate(90deg);
    * }
    * ```
     * @param shape_type Circle = 0; Line = 1;
     * @returns `new AudioVisual`
     */
    build(shape_type) {
        const shape = tslib_1.__classPrivateFieldGet(this, _AudioVisualBuilder_instances, "m", _AudioVisualBuilder_create_shape).call(this, shape_type);
        return new AudioVisual(tslib_1.__classPrivateFieldGet(this, _AudioVisualBuilder_analyzer_node, "f"), tslib_1.__classPrivateFieldGet(this, _AudioVisualBuilder_svg_injecting_element, "f"), shape, tslib_1.__classPrivateFieldGet(this, _AudioVisualBuilder_buffer_length, "f"), tslib_1.__classPrivateFieldGet(this, _AudioVisualBuilder_fft_multipier, "f"), tslib_1.__classPrivateFieldGet(this, _AudioVisualBuilder_fft_offset, "f"), tslib_1.__classPrivateFieldGet(this, _AudioVisualBuilder_from_fft_range, "f"), tslib_1.__classPrivateFieldGet(this, _AudioVisualBuilder_to_fft_range, "f"), tslib_1.__classPrivateFieldGet(this, _AudioVisualBuilder_point_count, "f"));
    }
}
exports.AudioVisualBuilder = AudioVisualBuilder;
_AudioVisualBuilder_analyzer_node = new WeakMap(), _AudioVisualBuilder_svg_injecting_element = new WeakMap(), _AudioVisualBuilder_canvas_height = new WeakMap(), _AudioVisualBuilder_canvas_width = new WeakMap(), _AudioVisualBuilder_buffer_length = new WeakMap(), _AudioVisualBuilder_smoothing_algorythm = new WeakMap(), _AudioVisualBuilder_fft_size = new WeakMap(), _AudioVisualBuilder_fft_multipier = new WeakMap(), _AudioVisualBuilder_fft_offset = new WeakMap(), _AudioVisualBuilder_from_fft_range = new WeakMap(), _AudioVisualBuilder_to_fft_range = new WeakMap(), _AudioVisualBuilder_point_count = new WeakMap(), _AudioVisualBuilder_instances = new WeakSet(), _AudioVisualBuilder_create_shape = function _AudioVisualBuilder_create_shape(shape_type) {
    const point_amount = tslib_1.__classPrivateFieldGet(this, _AudioVisualBuilder_instances, "m", _AudioVisualBuilder_get_cured_frequency_data).call(this).length;
    let new_shape;
    switch (shape_type) {
        case ShapeType.Line: {
            const points = [];
            for (let i = 0; i < point_amount; i++) {
                points.push({
                    x: (tslib_1.__classPrivateFieldGet(this, _AudioVisualBuilder_canvas_width, "f") / point_amount) * i,
                    y: tslib_1.__classPrivateFieldGet(this, _AudioVisualBuilder_canvas_height, "f") / 2 - (0 / point_amount) * i,
                });
            }
            new_shape = { shape_type, points, smoothing_algorythm: tslib_1.__classPrivateFieldGet(this, _AudioVisualBuilder_smoothing_algorythm, "f") };
            break;
        }
        case ShapeType.Circle: {
            const points = [];
            const radius = tslib_1.__classPrivateFieldGet(this, _AudioVisualBuilder_canvas_height, "f") > tslib_1.__classPrivateFieldGet(this, _AudioVisualBuilder_canvas_width, "f") ? tslib_1.__classPrivateFieldGet(this, _AudioVisualBuilder_canvas_height, "f") / 5 : tslib_1.__classPrivateFieldGet(this, _AudioVisualBuilder_canvas_width, "f") / 5;
            for (let i = 0; i < point_amount; i++) {
                points.push({
                    x: Math.cos(((2 * Math.PI) / point_amount) * i - Math.PI / 2) * radius,
                    y: Math.sin(((2 * Math.PI) / point_amount) * i - Math.PI / 2) * radius,
                });
            }
            new_shape = { shape_type, points, smoothing_algorythm: tslib_1.__classPrivateFieldGet(this, _AudioVisualBuilder_smoothing_algorythm, "f") };
            break;
        }
    }
    return new_shape;
}, _AudioVisualBuilder_get_cured_frequency_data = function _AudioVisualBuilder_get_cured_frequency_data() {
    const fft_data_array = new Float32Array(tslib_1.__classPrivateFieldGet(this, _AudioVisualBuilder_buffer_length, "f"));
    tslib_1.__classPrivateFieldGet(this, _AudioVisualBuilder_analyzer_node, "f").getFloatFrequencyData(fft_data_array);
    const from = Math.round((tslib_1.__classPrivateFieldGet(this, _AudioVisualBuilder_point_count, "f") / 100) * tslib_1.__classPrivateFieldGet(this, _AudioVisualBuilder_from_fft_range, "f"));
    const to = Math.round(tslib_1.__classPrivateFieldGet(this, _AudioVisualBuilder_buffer_length, "f") - (tslib_1.__classPrivateFieldGet(this, _AudioVisualBuilder_buffer_length, "f") / 100) * tslib_1.__classPrivateFieldGet(this, _AudioVisualBuilder_to_fft_range, "f"));
    const squeezeFactor = Math.round((tslib_1.__classPrivateFieldGet(this, _AudioVisualBuilder_buffer_length, "f") - to) / tslib_1.__classPrivateFieldGet(this, _AudioVisualBuilder_point_count, "f"));
    const return_array = new Array(tslib_1.__classPrivateFieldGet(this, _AudioVisualBuilder_point_count, "f"));
    for (let i = 0; i < tslib_1.__classPrivateFieldGet(this, _AudioVisualBuilder_point_count, "f"); i++) {
        return_array[i] = fft_data_array[from + i * squeezeFactor];
    }
    return return_array;
};
//# sourceMappingURL=index.js.map